using System.Text.Json.Serialization;
using Luski.Shared.PublicServers.V1.Shared;
using LuskiServer.Enums.ServerComs;

namespace LuskiServer.Classes.ServerComs;

public class ServerSendSendEvent
{
    [JsonInclude]
    [JsonPropertyName("data")]
    public ServerEvent Data { get; set; }

    [JsonInclude]
    [JsonPropertyName("send_type")]
    public SendType SendType { get; set; }
    
    [JsonInclude]
    [JsonPropertyName("id")]
    public long? ID { get; set; } = null;

    [JsonInclude]
    [JsonPropertyName("ids")]
    public long[]? IDS { get; set; } = null;
}

[JsonSerializable(typeof(ServerSendSendEvent))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
internal partial class ServerSendSendEventContext : JsonSerializerContext
{

}