using System.Text.Json.Serialization;
using Luski.Shared.PublicServers.V1.ServerToClient.WSS;
using LuskiServer.Interfaces.ServerComs;

namespace LuskiServer.Classes.ServerComs;

public class TokenEvent : WebsocketMessageSendEventSTC, IServerEvent
{
    [JsonInclude]
    [JsonPropertyName("token")]
    public string Token { get; set; }
    [JsonInclude]
    [JsonPropertyName("session_token")]
    public string? SessionToken { get; set; } = default!;
}

[JsonSerializable(typeof(TokenEvent))]
[JsonSourceGenerationOptions(
    GenerationMode = JsonSourceGenerationMode.Default,
    PropertyNamingPolicy = JsonKnownNamingPolicy.CamelCase,
    WriteIndented = false)]
internal partial class TokenEventContext : JsonSerializerContext
{

}