using System.Text;
using JacobTechEncryption.Enums;
using Luski.Shared.PublicServers.V1.Enums;
using ServerDatabase;
using ServerDatabase.SourceGenerator;

namespace LuskiServer.Classes.TableDef;

public static class Categories
{
    public static TableColumn<CategoryRow, long> ID { get; } = new("id", true);
    public static TableColumn<CategoryRow, byte[]> Name { get; } = new("name") { DefaultValue = Encoding.UTF8.GetBytes("New Category") };
    public static TableColumn<CategoryRow, byte[]> Description { get; } = new("description") { DefaultValue = Encoding.UTF8.GetBytes("Description") };
    public static TableColumn<CategoryRow, long> TitleEncryptionKey { get; } = new("title_encryption_key")
    {
        DefaultValue = 0,
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Keys,
            Column = Keys.ID
        }
    };
    public static TableColumn<CategoryRow, long> DescriptionEncryptionKey { get; } = new("description_encryption_key")
    {
        DefaultValue = 0,
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Keys,
            Column = Keys.ID
        }
    };
    public static TableColumn<CategoryRow, EncoderType> TitleEncoderType { get; } = new("title_encoder_type") { DefaultValue = EncoderType.UTF8 };
    public static TableColumn<CategoryRow, EncoderType> DescriptionEncoderType { get; } = new("description_encoder_type") { DefaultValue = EncoderType.UTF8 };
}
[TableRow(typeof(Categories))]
public partial class CategoryRow;