using Luski.Shared.PublicServers.V1.Enums;
using ServerDatabase;
using ServerDatabase.SourceGenerator;

namespace LuskiServer.Classes.TableDef;

public static class CategoryRoleOverrides
{
    public static TableColumn<CategoryRoleOverrideRow, long> Category { get; } = new("category", true)
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Categories,
            Column = Categories.ID
        }
    };
    public static TableColumn<CategoryRoleOverrideRow, long> RoleOverride { get; } = new("override", true)
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Roles,
            Column = Roles.ID
        }
    };
    public static TableColumn<CategoryRoleOverrideRow, ServerPermission> BadPermissions { get; } = new("bad_permissions");
    public static TableColumn<CategoryRoleOverrideRow, ServerPermission> GoodPermissions { get; } = new("good_permissions");
}

[TableRow(typeof(CategoryRoleOverrides))]
public partial class CategoryRoleOverrideRow;