using Luski.Shared.PublicServers.V1.Enums;
using ServerDatabase;
using ServerDatabase.SourceGenerator;

namespace LuskiServer.Classes.TableDef;

public static class CategoryUserOverrides
{
    public static TableColumn<CategoryUserOverrideRow, long> Category { get; } = new("category", true)
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Categories,
            Column = Categories.ID
        }
    };
    public static TableColumn<CategoryUserOverrideRow, long> UserOverride { get; } = new("override", true)
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Users,
            Column = Users.ID
        }
    };
    public static TableColumn<CategoryUserOverrideRow, ServerPermission> BadPermissions { get; } = new("bad_permissions");
    public static TableColumn<CategoryUserOverrideRow, ServerPermission> GoodPermissions { get; } = new("good_permissions");
}

[TableRow(typeof(CategoryUserOverrides))]
public partial class CategoryUserOverrideRow;