using ServerDatabase;
using ServerDatabase.SourceGenerator;

namespace LuskiServer.Classes.TableDef;

public static class ChannelKeys
{
    public static TableColumn<ChannelKeyRow, long> Key { get; } = new("key_id", true)
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Keys,
            Column = Keys.ID
        }
    };
    
    public static TableColumn<ChannelKeyRow, long> Channel { get; } = new("channel_id", true)
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Channels,
            Column = Channels.ID
        }
    };
}

[TableRow(typeof(ChannelKeys))]
public partial class ChannelKeyRow;