using Luski.Shared.PublicServers.V1.Enums;
using ServerDatabase;
using ServerDatabase.SourceGenerator;

namespace LuskiServer.Classes.TableDef;

public static class ChannelRoleOverrides
{
    public static TableColumn<ChannelRoleOverrideRow, long> Channel { get; } = new("channel", true)
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Channels,
            Column = Channels.ID
        }
    };
    public static TableColumn<ChannelRoleOverrideRow, long> RoleOverride { get; } = new("override", true)
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Roles,
            Column = Roles.ID
        }
    };
    public static TableColumn<ChannelRoleOverrideRow, ServerPermission> BadPermissions { get; } = new("bad_permissions");
    public static TableColumn<ChannelRoleOverrideRow, ServerPermission> GoodPermissions { get; } = new("good_permissions");
}

[TableRow(typeof(ChannelRoleOverrides))]
public partial class ChannelRoleOverrideRow;