using Luski.Shared.PublicServers.V1.Enums;
using ServerDatabase;
using ServerDatabase.SourceGenerator;

namespace LuskiServer.Classes.TableDef;

public static class ChannelUserOverrides
{
    public static TableColumn<ChannelUserOverrideRow, long> Channel { get; } = new("channel", true)
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Channels,
            Column = Channels.ID
        }
    };
    public static TableColumn<ChannelUserOverrideRow, long> UserOverride { get; } = new("override", true)
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Users,
            Column = Users.ID
        }
    };
    public static TableColumn<ChannelUserOverrideRow, ServerPermission> BadPermissions { get; } = new("bad_permissions");
    public static TableColumn<ChannelUserOverrideRow, ServerPermission> GoodPermissions { get; } = new("good_permissions");
}

[TableRow(typeof(ChannelUserOverrides))]
public partial class ChannelUserOverrideRow;