using JacobTechEncryption.Enums;
using ServerDatabase;
using ServerDatabase.SourceGenerator;

namespace LuskiServer.Classes.TableDef;

public static class Files
{
    public static TableColumn<FileRow, long> ID { get; } = new("id", true);
    public static TableColumn<FileRow, long> Owner { get; } = new("owner")
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Users,
            Column = Users.ID
        }
    };
    public static TableColumn<FileRow, bool> Public { get; } = new("public_download");
    public static TableColumn<FileRow, long> Size { get; } = new("size");
    public static TableColumn<FileRow, byte[]> Name { get; } = new("name");
    public static TableColumn<FileRow, byte[]> Hash { get; } = new("hash");
    public static TableColumn<FileRow, byte[]> Data { get; } = new("data");
    public static TableColumn<FileRow, long> EncryptionKey { get; } = new("encryption_key")
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Keys,
            Column = Keys.ID
        }
    };
    public static TableColumn<FileRow, EncoderType> EncoderType { get; } = new("encoder_type");
    public static TableColumn<FileRow, long> NameEncryptionKey { get; } = new("name_encryption_key")
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Keys,
            Column = Keys.ID
        }
    };
    public static TableColumn<FileRow, EncoderType> NameEncoderType { get; } = new("name_encoder_type");
}

[TableRow(typeof(Files))]
public partial class FileRow;