using JacobTechEncryption.Enums;
using ServerDatabase;
using ServerDatabase.SourceGenerator;

namespace LuskiServer.Classes.TableDef;

public static class Messages
{
    public static TableColumn<MessageRow, long> ID { get; } = new("id", true);
    public static TableColumn<MessageRow, long> Timestamp { get; } = new("message_timestamp");
    public static TableColumn<MessageRow, long> ChannelID { get; } = new("channel_id")
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Channels,
            Column = Channels.ID
        }
    };
    public static TableColumn<MessageRow, long> AuthorID { get; } = new("author_id")
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Users,
            Column = Users.ID
        }
    };
    public static TableColumn<MessageRow, long> ProfileID { get; } = new("profile_id")
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Profiles,
            Column = Profiles.ID
        }
    };
    public static TableColumn<MessageRow, byte[]> Context { get; } = new("context");
    public static TableColumn<MessageRow, long> EncryptionKey { get; } = new("encryption_key")
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Keys,
            Column = Keys.ID
        }
    };
    public static TableColumn<MessageRow, EncoderType> EncoderType { get; } = new("encoder_type");
    public static TableColumn<MessageRow, long> ReplyTo { get; } = new("reply_to");
}

[TableRow(typeof(Messages))]
public partial class MessageRow;