using Luski.Shared.PublicServers.V1.Enums;
using ServerDatabase;
using ServerDatabase.SourceGenerator;
using bob = Luski.Shared.PublicServers.V1.Enums.PictureType;

namespace LuskiServer.Classes.TableDef;

public class Profiles
{
    public static TableColumn<ProfileRow, long> ID { get; } = new("id", true);
    public static TableColumn<ProfileRow, string> DisplayName { get; } = new("displayname");
    public static TableColumn<ProfileRow, PictureType> PictureType { get; } = new("picture_type") {DefaultValue = bob.png };
    public static TableColumn<ProfileRow, byte[]> Picture { get; } = new("picture");
    public static TableColumn<ProfileRow, bool> CanUpdateName { get; } = new("update_name");
}

[TableRow(typeof(Profiles))]
public partial class ProfileRow;