using ServerDatabase;
using ServerDatabase.SourceGenerator;
using ServerDatabase.Utils.Enums;

namespace LuskiServer.Classes.TableDef;

public class RoleMembers
{
    public static TableColumn<RoleMemberRow, long> Role { get; } = new("role", true)
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Roles,
            Column = Roles.ID
        }
    };
    public static TableColumn<RoleMemberRow, long> User { get; } = new("user_id", true)
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Users,
            Column = Users.ID
        }
    };
}

[TableRow(typeof(RoleMembers))]
public partial class RoleMemberRow;