using Luski.Shared.PublicServers.V1.Enums;
using ServerDatabase;
using ServerDatabase.SourceGenerator;

namespace LuskiServer.Classes.TableDef;

public static class Roles
{
    public static TableColumn<RoleRow, long> ID { get; } = new("id", true);
    public static TableColumn<RoleRow, string> DisplayName { get; } = new("display_name") {DefaultValue = string.Empty};
    public static TableColumn<RoleRow, int> Index { get; } = new("index") {DefaultValue = 0 };
    public static TableColumn<RoleRow, ColorType> ColorType { get; } = new("color_type") { DefaultValue = Luski.Shared.PublicServers.V1.Enums.ColorType.Full};
    public static TableColumn<RoleRow, byte[]> Color { get; } = new("color") {DefaultValue = new byte[]{255,255,255,255}};
    public static TableColumn<RoleRow, string> Description { get; } = new("description") {DefaultValue = string.Empty};
    public static TableColumn<RoleRow, ServerPermission> ServerPermissions { get; } = new("server_perms");
}

[TableRow(typeof(Roles))]
public partial class RoleRow;