using ServerDatabase;
using ServerDatabase.SourceGenerator;

namespace LuskiServer.Classes.TableDef;

public static class SessionTokens
{
    public static TableColumn<SessionTokenRow, long> ID { get; } = new("id", true);
    public static TableColumn<SessionTokenRow, long> AccountID { get; } = new("account_id")
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Users,
            Column = Users.ID
        }
    };
    public static TableColumn<SessionTokenRow, string> Token { get; } = new("token");
    public static TableColumn<SessionTokenRow, byte[]> AddressFilter { get; } = new("address_filter");
    public static TableColumn<SessionTokenRow, DateTime> TimeFilter { get; } = new("date_filter");
}

[TableRow(typeof(SessionTokens))]
public partial class SessionTokenRow;