using ServerDatabase;
using ServerDatabase.SourceGenerator;
using ServerDatabase.Utils;
using ServerDatabase.Utils.Enums;

namespace LuskiServer.Classes.TableDef;

public static class Sessions
{
    public static TableColumn<SessionsRow, long> ID { get; } = new("id", true);
    public static TableColumn<SessionsRow, long> User { get; } = new("userid")
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Users,
            Column = Users.ID
        }
    };
    public static TableColumn<SessionsRow, string> WSSTCP { get; } = new("wsstcp");
    public static TableColumn<SessionsRow, string> Token { get; } = new("token");
    public static TableColumn<SessionsRow, string> LoginToken { get; } = new("login_token");
    public static TableColumn<SessionsRow, long> SessionKey { get; } = new("session_key")
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Keys,
            Column = Keys.ID
        }
    };
    public static TableColumn<SessionsRow, long> StorageID { get; } = new("storage_id");
}

[TableRow(typeof(Sessions))]
public partial class SessionsRow;
