using ServerDatabase;
using ServerDatabase.SourceGenerator;

namespace LuskiServer.Classes.TableDef;

public static class Storage
{
    public static TableColumn<StorageRow, long> ID { get; } = new("id", true);
    public static TableColumn<StorageRow, long> AccountID { get; } = new("account_id")
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Users,
            Column = Users.ID
        }
    };
    public static TableColumn<StorageRow, byte[]> Password { get; } = new("password");
    public static TableColumn<StorageRow, long> OfflineKey { get; } = new("offline_key")
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Keys,
            Column = Keys.ID
        }
    };
}

[TableRow(typeof(Storage))]
public partial class StorageRow;