using Luski.Shared.PublicServers.V1.Enums;
using ServerDatabase;
using ServerDatabase.SourceGenerator;
using ServerDatabase.Utils;
using ServerDatabase.Utils.Enums;
using bob = Luski.Shared.PublicServers.V1.Enums.PictureType;


namespace LuskiServer.Classes.TableDef;

public class Users
{
    public static TableColumn<UserRow, long> ID { get; } = new("id", true);
    public static TableColumn<UserRow, long> ServerProfile { get; } = new("server_profile")
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Profiles,
            Column = Profiles.ID,
            OnDelete = ConstraintAction.None
        }
    };
    public static TableColumn<UserRow, long> SelectedChannel { get; } = new("selected_channel")
    {
        ForeignKey = new ForeignKey()
        {
            Table = Tables.Channels,
            Column = Channels.ID,
            OnDelete = ConstraintAction.Restrict
        }
    };
    public static TableColumn<UserRow, UserStatus> Status { get; } = new("status") { DefaultValue = UserStatus.Offline };
    public static TableColumn<UserRow, byte[]> Username { get; } = new("username");
    public static TableColumn<UserRow, byte[]> Password { get; } = new("password");
    public static TableColumn<UserRow, byte[]> Salt { get; } = new("salt");
}

[TableRow(typeof(Users))]
public partial class UserRow;